
#define FEND   0300
#define FESC   0333
#define TFEND  0334
#define TFESC  0335

#define KISS_SMACK 0x80 /* smack support halves the # of ports */
#define KISS_RMNC  0x20 /* rmnc  support halves the # of ports */
#define KISS_CRC   0xA0 /* bitfields in kiss command byte */
#define KISS_PORT  0x50
#define KISS_OP    0x0F
#define KISS_DATA     0
#define KISS_TXD      1
#define KISS_P        2
#define KISS_ST       3
#define KISS_TXT      4
#define KISS_FD       5
#define KISS_HW       6
#define KISS_ACKMODE 12
#define KISS_POLL    14
#define KISS_EXIT   255 /* overrides bitfields XXX ?!? */

/* the kiss port/command byte is still in p[0]
 * returns 0 no crc, -1 something is wrong,
 * else the crc type bit */

int verify_kiss_crc(byte *p, int len);

/* cmd contains the crc type bit.
 * returned word ready for emit(&crc, 2) */

word calc_kiss_crc(byte *rest, word len, byte cmd);

