
	section .text2 ; not fncallable
	align  1

	global _ihypot

_ihypot           ; word ihypot(word a_in_E, word b_in_D);

	tste
	beq  L0       ; a was 0, result is b already in D
	xgde          ; exchange a and b, no effect on result
	tste
	beq  L0       ; b was 0, result is a now in D

	xgdx          ; save b
	ted           ; E and D both have a
	emul          ; ED = a * a
	pshm e,d      ; intermediate result (a^2) into stack (E at top)

	xgdx          ; restore b
	tde           ; E and D both have b
	emul          ; ED has (b^2)

	tsx           ; X now free to point to locals
	addd 2,x
	adce 0,x      ; ED has a^2 + b^2
	ais  #+4      ; purge temporaries
	bcc  _isqrt   ; continue to square root if no overflow (returns to caller)

	ldd #0FFFFh   ; did overflow, return max possible
L0
	rts

	;
	; hats off to old man Jack Crenshaw of embedded.com
	;
	; for 16-bit result, 'root' needs 17 bits and 'rem' 18.
	; this only provides 14 valid result bits.
	; error is 0 for results 0 ... 16k
	; error -1 or 0 for results 16k ... 32k
	; error -3 ... 0 for results 32k ... 64k
	;
	; input is first justified to the left,
	; and loop count decremented accordingly.
	;
	; 230 ... 320 usec per call, depending on argument width
	; 

	global _isqrt

_isqrt            ; word isqrt(dword ED)
	ldy  # 15     ; always at least one loop less than "normal"

	cpe  # 4000h
	blo  justify  ; two msbits 0, skip some more loops

	bsr  churn    ; arg / 4, effectively, when not shifted at all
	asld          ; result * 2
	rts

again
	aiy  #-1
	bne  justify

	clrd
	rts           ; zero in, zero out

justify
	asld
	role
	asld
	role
	cpe  # 4000h
	blo  again    ; as long as top two bits are zero

churn
	xgex          ; first input bits in IX
	clre          ; rem = 0

	cpy  # 8
	bls  L3       ; only E has some bits

	aiy  #-8      ; so many loops for bits in D
	pshm d,y
	ldy  # 8      ; so many for first bits
	clrd          ; root = 0. really the 'divisor'
	bsr  kirnu
	pulm x,y
	bsr  kirnu
	lsrd          ; final fixup, it was 'divisor' really before this.
	rts           ; rem is still in E, if anyone is interested.
L3
	clrd
	bsr  kirnu
	lsrd
	rts

kirnu
	xgdx          ; ASLW INDEXED is rather slow, thus this two-step dance.
	asld          ; did not buy much, max 390 usec down to 320 usec
	role
	asld
	role          ; rem <<= 2; rem += TOP2BITS(x); x <<= 2;
	xgdx

	asld          ; root <<= 1;
	addd # 1      ; root++;
	sde
	bcc  L2       ; branch if success
	ade           ; undo SDE
	addd #-2      ; undo increments to root, above and below
L2
	addd # 1
	aiy  #-1
	bne  kirnu    ; churn it
	rts


	global _isqrt_sigh

_isqrt_sigh
	cpe  # 4000h
	bhi  dancing  ; because of EMULS
L5
	pshm e,d      ; arg + 1 into stack
	tsx           ; because SBCE does not have a sticky Z behavior
	xgdy          ; arg in E:Y
	ldd  # 4000h  ; first trial bit
	incw 2,x
	bne  L7
	incw 0,x      ; no carry here, ED was less than 0x4000'0000
	bra  L7
L6
	lsrd
	beq  L10      ; arg zero, result zero.
	xgdy
	asld
	role
	asld
	role
	xgdy
L7
	cpe  # 1000h
	blo  L6       ; skip one more loop
	clre          ; accu
L8
	pshm e,d
	ade
	ted
	emuls         ; just a tad faster than EMUL
	subd 2,x
	sbce 0,x
	pulm e,d
	bcc  L9
	ade
L9
	lsrd
	bne  L8
	ted
L10
	ais  #+4
	rts

dancing
	pshm e,d
	lsre
	rord
	lsre
	rord
	bsr  L5     ; calculate sqrt(ED / 4)
	tsx
	pshm d
	asld        ; times 2
	orab # 1    ; so much trouble for one lousy lsbit
	tde
	emul
	subd 2,x
	sbce 0,x
	pulm d
	rold
	eorb # 1
	ais  #+4
	rts

